﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using sl_ChartView_ticket_519602.Models;
using sl_ChartView_ticket_519602.ViewModels;
using Telerik.Windows.Controls.ChartView;

namespace sl_ChartView_ticket_519602
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void RadGridView_SelectionChanged(object sender, Telerik.Windows.Controls.SelectionChangeEventArgs e)
        {
            if (e.AddedItems.Count == 0)
                return;
                       
            this.ZoomChart_PanOffsetZoom((Interval)e.AddedItems[0]); 
        }

        private void ZoomChart_PanOffsetZoom(Interval interval)
        {
            var mainViewModel = this.Resources["vm"] as MainViewModel;

            double minDate = mainViewModel.Infos.First().Date.ToOADate();
            double maxDate = mainViewModel.Infos.Last().Date.ToOADate();
            double selectedStart = interval.StartDate.ToOADate();
            double selectedEnd = interval.EndDate.ToOADate();
            
            double axisWidth = this.radChartView.PlotAreaClip.Width;
            double range = maxDate - minDate;
            double rangeToSelectionQuotient = range / (selectedEnd - selectedStart);

            double actualAxisWidth_Pixels = axisWidth * rangeToSelectionQuotient;
            double normalizedOffset = (selectedStart - minDate) / range;
            
            double selection = (selectedEnd - selectedStart);
            if (selection > 0 && range > 0)
                mainViewModel.Zoom = new Size(range / selection, 1);

            mainViewModel.PanOffset = new Point(-normalizedOffset * actualAxisWidth_Pixels, mainViewModel.PanOffset.Y);
        }       
    }
}
