﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.Generic;
using sl_ChartView_ticket_519602.Models;

namespace sl_ChartView_ticket_519602.ViewModels
{
    public class MainViewModel : ViewModelBase
    {
        public List<TemperatureInfo> Infos { get; private set; }
        public List<Interval> Intervals { get; private set; }

        public MainViewModel()
        {
            DateTime now = new DateTime(2012, 3, 9);

            this.Infos = new List<TemperatureInfo>() 
            { 
                new TemperatureInfo { Date = now.AddDays(-20), Value = 15, },
                new TemperatureInfo { Date = now.AddDays(-19), Value = 25, },
                new TemperatureInfo { Date = now.AddDays(-18), Value = 16, },
                new TemperatureInfo { Date = now.AddDays(-17), Value = 12, },
                new TemperatureInfo { Date = now.AddDays(-16), Value = 5, },
                new TemperatureInfo { Date = now.AddDays(-15), Value = 25, },
                new TemperatureInfo { Date = now.AddDays(-14), Value = 35, },
                new TemperatureInfo { Date = now.AddDays(-13), Value = 35, },
                new TemperatureInfo { Date = now.AddDays(-12), Value = 33, },
                new TemperatureInfo { Date = now.AddDays(-11), Value = 15, },
                new TemperatureInfo { Date = now.AddDays(-10), Value = 22, },
                new TemperatureInfo { Date = now.AddDays(-9), Value = 21, },
                new TemperatureInfo { Date = now.AddDays(-8), Value = 12, },
                new TemperatureInfo { Date = now.AddDays(-7), Value = 12, },
                new TemperatureInfo { Date = now.AddDays(-6), Value = 13, },
                new TemperatureInfo { Date = now.AddDays(-5), Value = 17, },
                new TemperatureInfo { Date = now.AddDays(-4), Value = 16, },
                new TemperatureInfo { Date = now.AddDays(-3), Value = 17, },
                new TemperatureInfo { Date = now.AddDays(-2), Value = 16, },
                new TemperatureInfo { Date = now.AddDays(-1), Value = 11, },
                new TemperatureInfo { Date = now.AddDays(0), Value = 5, },
                new TemperatureInfo { Date = now.AddDays(1), Value = 3, },
                new TemperatureInfo { Date = now.AddDays(2), Value = 25, },
                new TemperatureInfo { Date = now.AddDays(3), Value = 33, },
                new TemperatureInfo { Date = now.AddDays(4), Value = 31, },
            };

            this.Intervals = new List<Interval>() 
            {
                new Interval { StartDate = now.AddDays(-20), EndDate = now.AddDays(4),}, 
                new Interval { StartDate = now.AddDays(-18), EndDate = now.AddDays(0),}, 
                new Interval { StartDate = now.AddDays(-5), EndDate = now.AddDays(-1),}, 
                new Interval { StartDate = now.AddDays(0), EndDate = now.AddDays(3),}, 
                new Interval { StartDate = now.AddDays(-11), EndDate = now.AddDays(4),}, 
                new Interval { StartDate = now.AddDays(-9), EndDate = now.AddDays(-6),}, 
                new Interval { StartDate = now.AddDays(-9), EndDate = now.AddDays(0),}, 
                new Interval { StartDate = now.AddDays(-9), EndDate = now.AddDays(3),}, 
            };
        }

        private Point panOffset;
        public Point PanOffset 
        {
            get { return this.panOffset; }
            set
            {
                if (this.panOffset != value)
                {
                    this.panOffset = value;
                    this.OnPropertyChanged("PanOffset");
                }
            }
        }

        private Size zoom = new Size(1, 1);
        public Size Zoom
        {
            get { return this.zoom; }
            set
            {
                if (this.zoom != value)
                {
                    this.zoom = value;
                    this.OnPropertyChanged("Zoom");
                }
            }
        }
    }
}
